%define rtspclient_user rtspclient

Summary: FFmpeg based RTSP client
Name: ffmpeg-rtsp-client
Version: 0.2.2
Release: 1
URL: https://git.tilab.tuwien.ac.at/sw/ffmpeg-rtsp-client
Source0: %{name}-%{version}.tar.xz
License: GPL

BuildArch: noarch

Requires: bash
Requires: coreutils
Requires: ffmpeg
Requires: ImageMagick

BuildRequires: systemd

%description
A configurable client for RTSP servers using ffmpeg for grabbing,
encoding and streaming to a server.

%prep
%setup -q

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{%{_sysconfdir}/%{name},%{_unitdir}} \
      %{buildroot}{%{_sharedstatedir}/%{name},%{_bindir},%{_libexecdir}}
cp bin/* %{buildroot}%{_bindir}/.

# systemd service
cp %{name}.service "%{buildroot}%{_unitdir}"

# empty config file
touch %{buildroot}%{_sysconfdir}/%{name}/rtsp.conf

%clean
rm -rf %{buildroot}

%post
systemctl daemon-reload
convert \
    -size 640x480 \
    -background none \
    -fill white \
    -strokewidth 1 \
    -stroke black \
    -pointsize 42 \
    -gravity Center \
    caption:"$(hostname -s)" \
    -trim \
    %{_sysconfdir}/%{name}/default-overlay.png

%pre
# add our user if it does not exist
getent passwd %{rtspclient_user} >/dev/null || {
    useradd --system --create-home \
        --home-dir /home/%{rtspclient_user} \
        --comment "Remote Place Assigner Daemon" \
        -G audio,video \
        %{rtspclient_user}
}

%preun
if [ "$1" == 0 ]
then #uninstall
    systemctl unmask %{name}.service
    systemctl stop %{name}.service
    systemctl disable %{name}.service
    rm -f %{_sysconfdir}/%{name}/default-overlay.png
fi

%postun
if [ "$1" == 0 ]
then #uninstall
    # remove our user
    userdel --remove "%{rtspclient_user}" >/dev/null 2>&1 || \
        echo "warning: failed to remove user %{rtspclient_user}" >&2

    systemctl daemon-reload
    systemctl reset-failed
fi

%files
%defattr(-,root,root)
%doc doc/*
%dir %attr(0770,%{rtspclient_user},root) %{_sysconfdir}/%{name}
%config %attr(0660,%{rtspclient_user},root) %{_sysconfdir}/%{name}/rtsp.conf
%attr(0755,-,-) %{_bindir}/%{name}
%attr(644,root,root) %{_unitdir}/%{name}.service
